/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

void  prntIBDTHead (int);
void  prntIBDTColNorm (int, int, int, int, int);
void  prntIBDTColPerm (int, int, int, int, int);
void  prntIBDTColChiSq (int, int);
void  prntIBDTLocPos (int);

static int LenCol1;

void prntIBDTHead (int stat_test)
{
   if (stat_test == NORMAL)
   {
      printf ("\n *******************************\n");
      printf (" p Value for Normal Test for IBD\n");
      printf (" *******************************\n");
   }
   else if (stat_test == PERMUTATION)
   {
      printf ("\n ************************************\n");
      printf (" p Value for Permutation Test for IBD\n");
      printf (" ************************************\n");
   }
   else if (stat_test == CHISQUARE)
   {
      printf ("\n ********************************************\n");
      printf (" p Value for Chi-Square Likelihood-ratio Test\n");
      printf (" ********************************************\n");
   }
   return;
}

void prntIBDTColNorm (int spairs, int srobdom, int saffunaff, int slambda,
                      int maxFGL)
{
   LenCol1 = LocNamLen > 5 ? LocNamLen : 5;
   printf ("\n %*s%17s", LenCol1, " ", "pos(Haldane cM)");

   printf ("\n %*s  %7s %7s", LenCol1, "locus", "male", "female");
   if (spairs)
      printf (" %8s %7s", "Spairs", "p-value");
   if (srobdom)
      printf (" %8s %7s", "Srobdom", "p-value");
   if (saffunaff)
      printf (" %8s %7s", "Saffunaff", "p-value");
   if (slambda)
      printf (" %8s %7s", "Slambda", "p-value");
   if (maxFGL)
      printf (" %8s, %7s", "MaxFGL", "p-value");
   printf ("\n\n");

   return;
}

void prntIBDTColPerm (int spairs, int srobdom, int saffunaff, int slambda,
                      int maxFGL)
{
   LenCol1 = LocNamLen > 5 ? LocNamLen : 5;
   printf ("\n %*s%17s", LenCol1, " ", "pos(Haldane cM)");
   if (spairs)
      printf (" %8s", "Spairs");
   if (srobdom)
      printf (" %8s", "Srobdom");
   if (saffunaff)
      printf (" %8s", "Saffunaf");
   if (slambda)
      printf (" %8s", "Slambda");
   if (maxFGL)
      printf (" %8s", "MaxFGL");

   printf ("\n %*s  %7s %7s", LenCol1, "locus", "male", "female");
   if (spairs)
      printf (" %8s", "p-value");
   if (srobdom)
      printf (" %8s", "p-value");
   if (saffunaff)
      printf (" %8s", "p-value");
   if (slambda)
      printf (" %8s", "p-value");
   if (maxFGL)
      printf (" %8s", "p-value");
   printf ("\n\n");

   return;
}

void prntIBDTColChiSq (int delta, int lambda_p)
{
   LenCol1 = LocNamLen > 5 ? LocNamLen : 5;
   printf ("\n %*s%17s", LenCol1, " ", "pos(Haldane cM)");
   if (lambda_p)
      printf (" %8s %7s", "2log LR", " ");
   if (delta)
      printf (" %8s %7s %7s", "hat", "2log LR", " ");

   printf ("\n %*s  %7s %7s", LenCol1, "locus", "male", "female");
   if (lambda_p)
      printf (" %8s %7s", "lambda,p", "p-value");
   if (delta)
      printf (" %8s %7s %7s", "delta", "delta", "p-value");
   printf ("\n\n");

   return;
}

void prntIBDTLocPos (int loc)
{
   printf (" %*s", LenCol1, MarkNam[loc - 1]);

   printf ("%9.3f%8.3f", MarkPos[0][loc - 1], MarkPos[1][loc - 1]);

   return;
}
