/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* setup_peel.h:  Header file that brings in all functions and defines    */
/*                preprocessor variables used by 'cnv_peel.c' and         */
/*                'locus_peel.c'.                                         */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/


#define SIM 0        /* 1 --> simulate error; 0 --> do not simuate errors */
#define CHAIN 1
#define SMALL 1.0e-06
#define SCALE 1.0e06
#define MXPSQ 650    /* The length of the longest peeling sequence        */
#define BIG 200000   /* Memory to store peeling fncts (maxfmsz * genty^2) */
#define NP 20000     /* The largest index of all indivs. providing phenos */
#define NG 100       /* The number of possible geno in population         */
#define PNG 10000    /* The number of possible mating types in population */
#define NI 20        /* The largest possible cluster size                 */
#define NST 100      /* The max number of pivots across all peeling seqs. */

/* CURRENT CUMULATIVE PENETRANCES, INDIVIDUAL GENOTYPES  */
        double pen[NI+1];
        int igen[NI], invol[NI];

/* CURRENT POSITIONS ETC. OF INDIVIDUALS OF PARENT OFFSPRING TRIPLETS 
   INVOLVED IN CURRENT OPERATION  (# triplets < NI)    */
        int itrip[4][NI], mtrip[NI];
      
/* POSITIONS OF INDIVIDUALS IN R-FUNCTIONS CURRENTLY INVOLVED, AND
   NUMBERS AND POSITIONS IN PRLIK ETC. (# prevlik < NI) */
        int iprlik[NI+1][NI], nprlik[NI], nstlik[NI], maxlik[NI];

/* CHILDEREN IN CURRENTLY INVOLVED SIBSHIP; ONLY CHILDREN PEELED FROM/TO 
        INCLUDED */
        int ich[NI];

/* STORAGE SPACE FOR R-FUNCTIONS, AND OUTPUT R-FUNCTION. 
     FIRST ngenty TERMS OF store CONTAIN R-FUNCTION FOR ANY NOT
     PREVIOUSLY CONSIDERED FOUNDER PARENT. 
   ALSO MARGINAL R-FUNCTIONS FOR INTERMEDIATE NAME SET INDIVIDUALS.  */
        double store[2*BIG], fmarg[NI][NG+1];

/*  NAMES IN STORED R-FUNCTIONS, POSITION IN STORAGE, AND INDEX FOR
      FUTURE REQUIREMENT. */
        int namsto[NST][NI], nstart[NST], ndex[NST], nindi[NST];

/*
  IMPOSS=POSITION OF FIRST INDIVIDUAL FOR WHICH THE CURRENT GENOTYPE
    SET IS IMPOSSIBLE.
  IPLACE=FIRST INDIVIDUAL TO HAVE BEEN RESET IN CURRENT GENOTYPE SET.
  NINVOL= # INDIVIDUALS INVOLVED IN CURRENT OPERATION
  NOUTIN= # INDIVIDUALS IN OUTPUT SET OF CURRENT OPERATION.
  NSTORE = # STORED R-FUNCTIONS (INCLUDING FOUNDER R-FUNCTION)  

      COMMON NGENTY,NSTORE,STORE,NSTART,INDEX,NINDI,NAMSTO   */

   int ngenty, nphen, ngng, npeop, npeph;
   int nstore, nextst, noutin, ntrip, nsib, nlik, npar, ninvol, iwrt;
   int im, ife, iim, iife, ifoum, ifoufe, iplace, iout, imposs;

void pr_person( int );

void prev_functions(), repack(), varlik();

int rescale();

struct myInd                      /* Complements nghds struct in zloop.c  */
{
  int prev_rf, peeled;
  int married, nspouses, foun, nome;
};
typedef struct myInd MyInd;
MyInd *MyIndPtr;

int get_pivot(int, int, int *, int, int **, int);
                                 /* Finds the pivot of a cluster and     */
                                 /* contributes to the peeling sequence  */
                                 /* if the cluster can be peeled         */
void get_peelseq (int **);       /* Creates zero loop peeling sequence   */

