/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* r1mach.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__25 = 25;
static integer c__1 = 1;
static integer c__2 = 2;

doublereal r1mach_ (i__)
     integer *i__;
{
   /* Initialized data */

   static struct
   {
      integer e_1;
      integer fill_2[1];
      integer e_3;
      integer fill_4[1];
      integer e_5;
      integer fill_6[1];
      integer e_7;
      integer fill_8[1];
      integer e_9;
      integer fill_10[1];
      doublereal e_11;
   } equiv_4 =
   {
      8388608,
      {
      0}, 2139095039,
      {
      0}, 864026624,
      {
      0}, 872415232,
      {
      0}, 1050288283,
      {
   0}, 0.};

   /* System generated locals */
   doublereal ret_val;

   /* Local variables */
#define log10 ((integer *)&equiv_4 + 8)
#define large ((integer *)&equiv_4 + 2)
#define rmach ((doublereal *)&equiv_4)
#define small ((integer *)&equiv_4)
#define diver ((integer *)&equiv_4 + 6)
#define right ((integer *)&equiv_4 + 4)
   extern /* Subroutine */ int xerror_ ();

/* ***BEGIN PROLOGUE  R1MACH */
/* ***DATE WRITTEN   790101   (YYMMDD) */
/* ***REVISION DATE  860825   (YYMMDD) */
/* ***CATEGORY NO.  R1 */
/* ***KEYWORDS  MACHINE CONSTANTS */
/* ***AUTHOR  FOX, P. A., (BELL LABS) */
/*           HALL, A. D., (BELL LABS) */
/*           SCHRYER, N. L., (BELL LABS) */
/* ***PURPOSE  Returns single precision machine dependent constants */
/* ***DESCRIPTION */

/*     R1MACH can be used to obtain machine-dependent parameters */
/*     for the local machine environment.  It is a function */
/*     subroutine with one (input) argument, and can be called */
/*     as follows, for example */

/*          A = R1MACH(I) */

/*     where I=1,...,5.  The (output) value of A above is */
/*     determined by the (input) value of I.  The results for */
/*     various values of I are discussed below. */

/*  Single-Precision Machine Constants */
/*  R1MACH(1) = B**(EMIN-1), the smallest positive magnitude. */
/*  R1MACH(2) = B**EMAX*(1 - B**(-T)), the largest magnitude. */
/*  R1MACH(3) = B**(-T), the smallest relative spacing. */
/*  R1MACH(4) = B**(1-T), the largest relative spacing. */
/*  R1MACH(5) = LOG10(B) */
/* ***REFERENCES  FOX, P.A., HALL, A.D., SCHRYER, N.L, *FRAMEWORK FOR */
/*                 A PORTABLE LIBRARY*, ACM TRANSACTIONS ON MATHE- */
/*                 MATICAL SOFTWARE, VOL. 4, NO. 2, JUNE 1978, */
/*                 PP. 177-188. */
/* ***ROUTINES CALLED  XERROR */
/* ***END PROLOGUE  R1MACH */

/*     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM. */

/*     DATA RMACH(1) / Z400800000 / */
/*     DATA RMACH(2) / Z5FFFFFFFF / */
/*     DATA RMACH(3) / Z4E9800000 / */
/*     DATA RMACH(4) / Z4EA800000 / */
/*     DATA RMACH(5) / Z500E730E8 / */

/*     MACHINE CONSTANTS FOR THE BURROUGHS 5700/6700/7700 SYSTEMS. */

/*     DATA RMACH(1) / O1771000000000000 / */
/*     DATA RMACH(2) / O0777777777777777 / */
/*     DATA RMACH(3) / O1311000000000000 / */
/*     DATA RMACH(4) / O1301000000000000 / */
/*     DATA RMACH(5) / O1157163034761675 / */

/*     MACHINE CONSTANTS FOR THE CONVEX C-120 (NATIVE MODE) */

/*     DATA RMACH(1) / 2.9387360E-39 / */
/*     DATA RMACH(2) / 1.7014117E+38 / */
/*     DATA RMACH(3) / 5.9604645E-08 / */
/*     DATA RMACH(4) / 1.1920929E-07 / */
/*     DATA RMACH(5) / 3.0102999E-01 / */

/*     MACHINE CONSTANTS FOR THE CONVEX C-120 (NATIVE MODE) */
/*     WITH -R8 OPTION */

/*     DATA RMACH(1) / 5.562684646268007D-309 / */
/*     DATA RMACH(2) / 8.988465674311577D+307 / */
/*     DATA RMACH(3) / 1.110223024625157D-016 / */
/*     DATA RMACH(4) / 2.220446049250313D-016 / */
/*     DATA RMACH(5) / 3.010299956639812D-001 / */

/*     MACHINE CONSTANTS FOR THE CONVEX C-120 (IEEE MODE) */

/*     DATA RMACH(1) / 1.1754945E-38 / */
/*     DATA RMACH(2) / 3.4028234E+38 / */
/*     DATA RMACH(3) / 5.9604645E-08 / */
/*     DATA RMACH(4) / 1.1920929E-07 / */
/*     DATA RMACH(5) / 3.0102999E-01 / */

/*     MACHINE CONSTANTS FOR THE CONVEX C-120 (IEEE MODE) */
/*     WITH -R8 OPTION */

/*     DATA RMACH(1) / 2.225073858507202D-308 / */
/*     DATA RMACH(2) / 1.797693134862315D+308 / */
/*     DATA RMACH(3) / 1.110223024625157D-016 / */
/*     DATA RMACH(4) / 2.220446049250313D-016 / */
/*     DATA RMACH(5) / 3.010299956639812D-001 / */

/*     MACHINE CONSTANTS FOR THE CDC CYBER 170 SERIES (FTN5). */

/*      DATA RMACH(1) / O"00014000000000000000" / */
/*      DATA RMACH(2) / O"37767777777777777777" / */
/*      DATA RMACH(3) / O"16404000000000000000" / */
/*      DATA RMACH(4) / O"16414000000000000000" / */
/*      DATA RMACH(5) / O"17164642023241175720" / */

/*     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE */

/*     DATA RMACH(1) / Z"3001800000000000" / */
/*     DATA RMACH(2) / Z"4FFEFFFFFFFFFFFE" / */
/*     DATA RMACH(3) / Z"3FD2800000000000" / */
/*     DATA RMACH(4) / Z"3FD3800000000000" / */
/*     DATA RMACH(5) / Z"3FFF9A209A84FBCF" / */

/*     MACHINE CONSTANTS FOR THE CDC CYBER 205 */

/*     DATA RMACH(1) / X'9000400000000000' / */
/*     DATA RMACH(2) / X'6FFF7FFFFFFFFFFE' / */
/*     DATA RMACH(3) / X'FFA3400000000000' / */
/*     DATA RMACH(4) / X'FFA4400000000000' / */
/*     DATA RMACH(5) / X'FFD04D104D427DE8' / */

/*     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES. */

/*     DATA RMACH(1) / 00564000000000000000B / */
/*     DATA RMACH(2) / 37767777777777777776B / */
/*     DATA RMACH(3) / 16414000000000000000B / */
/*     DATA RMACH(4) / 16424000000000000000B / */
/*     DATA RMACH(5) / 17164642023241175720B / */

/*     MACHINE CONSTANTS FOR THE CRAY 1 */

/*     DATA RMACH(1) / 200034000000000000000B / */
/*     DATA RMACH(2) / 577767777777777777776B / */
/*     DATA RMACH(3) / 377224000000000000000B / */
/*     DATA RMACH(4) / 377234000000000000000B / */
/*     DATA RMACH(5) / 377774642023241175720B / */

/*     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200 */

/*     NOTE - IT MAY BE APPROPRIATE TO INCLUDE THE FOLLOWING CARD - */
/*     STATIC RMACH(5) */

/*     DATA SMALL/20K,0/,LARGE/77777K,177777K/ */
/*     DATA RIGHT/35420K,0/,DIVER/36020K,0/ */
/*     DATA LOG10/40423K,42023K/ */

/*     MACHINE CONSTANTS FOR THE HARRIS 220 */

/*     DATA SMALL(1),SMALL(2) / '20000000, '00000201 / */
/*     DATA LARGE(1),LARGE(2) / '37777777, '00000177 / */
/*     DATA RIGHT(1),RIGHT(2) / '20000000, '00000352 / */
/*     DATA DIVER(1),DIVER(2) / '20000000, '00000353 / */
/*     DATA LOG10(1),LOG10(2) / '23210115, '00000377 / */

/*     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES. */

/*     DATA RMACH(1) / O402400000000 / */
/*     DATA RMACH(2) / O376777777777 / */
/*     DATA RMACH(3) / O714400000000 / */
/*     DATA RMACH(4) / O716400000000 / */
/*     DATA RMACH(5) / O776464202324 / */

/*     MACHINE CONSTANTS FOR THE HP 2100 */
/*     3 WORD DOUBLE PRECISION WITH FTN4 */

/*     DATA SMALL(1), SMALL(2) / 40000B,       1 / */
/*     DATA LARGE(1), LARGE(2) / 77777B, 177776B / */
/*     DATA RIGHT(1), RIGHT(2) / 40000B,    325B / */
/*     DATA DIVER(1), DIVER(2) / 40000B,    327B / */
/*     DATA LOG10(1), LOG10(2) / 46420B,  46777B / */

/*     MACHINE CONSTANTS FOR THE HP 2100 */
/*     4 WORD DOUBLE PRECISION WITH FTN4 */

/*     DATA SMALL(1), SMALL(2) / 40000B,       1 / */
/*     DATA LARGE91), LARGE(2) / 77777B, 177776B / */
/*     DATA RIGHT(1), RIGHT(2) / 40000B,    325B / */
/*     DATA DIVER(1), DIVER(2) / 40000B,    327B / */
/*     DATA LOG10(1), LOG10(2) / 46420B,  46777B / */

/*     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES, */
/*     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86  AND */
/*     THE PERKIN ELMER (INTERDATA) 7/32. */

/*     DATA RMACH(1) / Z00100000 / */
/*     DATA RMACH(2) / Z7FFFFFFF / */
/*     DATA RMACH(3) / Z3B100000 / */
/*     DATA RMACH(4) / Z3C100000 / */
/*     DATA RMACH(5) / Z41134413 / */

/*     MACHINE CONSTANTS FOR THE PDP-10 (KA OR KI PROCESSOR). */

/*     DATA RMACH(1) / "000400000000 / */
/*     DATA RMACH(2) / "377777777777 / */
/*     DATA RMACH(3) / "146400000000 / */
/*     DATA RMACH(4) / "147400000000 / */
/*     DATA RMACH(5) / "177464202324 / */

/*     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING */
/*     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL). */

/*     DATA SMALL(1) /    8388608 / */
/*     DATA LARGE(1) / 2147483647 / */
/*     DATA RIGHT(1) /  880803840 / */
/*     DATA DIVER(1) /  889192448 / */
/*     DATA LOG10(1) / 1067065499 / */

/*     DATA RMACH(1) / O00040000000 / */
/*     DATA RMACH(2) / O17777777777 / */
/*     DATA RMACH(3) / O06440000000 / */
/*     DATA RMACH(4) / O06500000000 / */
/*     DATA RMACH(5) / O07746420233 / */

/*     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING */
/*     16-BIT INTEGERS  (EXPRESSED IN INTEGER AND OCTAL). */

/*     DATA SMALL(1),SMALL(2) /   128,     0 / */
/*     DATA LARGE(1),LARGE(2) / 32767,    -1 / */
/*     DATA RIGHT(1),RIGHT(2) / 13440,     0 / */
/*     DATA DIVER(1),DIVER(2) / 13568,     0 / */
/*     DATA LOG10(1),LOG10(2) / 16282,  8347 / */

/*     DATA SMALL(1),SMALL(2) / O000200, O000000 / */
/*     DATA LARGE(1),LARGE(2) / O077777, O177777 / */
/*     DATA RIGHT(1),RIGHT(2) / O032200, O000000 / */
/*     DATA DIVER(1),DIVER(2) / O032400, O000000 / */
/*     DATA LOG10(1),LOG10(2) / O037632, O020233 / */

/*     MACHINE CONSTANTS FOR THE SUN 3 (68881 OR FPA) */

/*     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES. */

/*     DATA RMACH(1) / O000400000000 / */
/*     DATA RMACH(2) / O377777777777 / */
/*     DATA RMACH(3) / O146400000000 / */
/*     DATA RMACH(4) / O147400000000 / */
/*     DATA RMACH(5) / O177464202324 / */

/*     MACHINE CONSTANTS FOR THE VAX 11/780 */
/*    (EXPRESSED IN INTEGER AND HEXADECIMAL) */
/*  ***THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS*** */
/*  *** THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS*** */

/*     DATA SMALL(1) /       128 / */
/*     DATA LARGE(1) /    -32769 / */
/*     DATA RIGHT(1) /     13440 / */
/*     DATA DIVER(1) /     13568 / */
/*     DATA LOG10(1) / 547045274 / */

/*     DATA SMALL(1) / Z00000080 / */
/*     DATA LARGE(1) / ZFFFF7FFF / */
/*     DATA RIGHT(1) / Z00003480 / */
/*     DATA DIVER(1) / Z00003500 / */
/*     DATA LOG10(1) / Z209B3F9A / */

/*     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR */

/*     DATA SMALL(1),SMALL(2) /     0,    256/ */
/*     DATA LARGE(1),LARGE(2) /    -1,   -129/ */
/*     DATA RIGHT(1),RIGHT(2) /     0,  26880/ */
/*     DATA DIVER(1),DIVER(2) /     0,  27136/ */
/*     DATA LOG10(1),LOG10(2) /  8347,  32538/ */

/* ***FIRST EXECUTABLE STATEMENT  R1MACH */
   if (*i__ < 1 || *i__ > 5)
   {
      xerror_ ("R1MACH -- I OUT OF BOUNDS", &c__25, &c__1, &c__2, (ftnlen) 25);
   }

   ret_val = rmach[*i__ - 1];
   return ret_val;

}                                       /* r1mach_ */

#undef right
#undef diver
#undef small
#undef rmach
#undef large
#undef log10
