/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* rg.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rg_ (nm, n, a, wr, wi, matz, z__, iv1, fv1, ierr)
     integer *nm, *n;
     doublereal *a, *wr, *wi;
     integer *matz;
     doublereal *z__;
     integer *iv1;
     doublereal *fv1;
     integer *ierr;
{
   /* System generated locals */
   integer a_dim1, a_offset, z_dim1, z_offset;

   /* Local variables */
   extern /* Subroutine */ int balbak_ (), balanc_ (), elmhes_ (), eltran_ ();
   static integer is1, is2;
   extern /* Subroutine */ int hqr_ (), hqr2_ ();

/* ***BEGIN PROLOGUE  RG */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4A2 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Computes eigenvalues and, optionally, eigenvectors of a */
/*            DOUBLE PRECISION general matrix. */
/* ***DESCRIPTION */

/*     This subroutine calls the recommended sequence of */
/*     subroutines from the eigensystem subroutine package (EISPACK) */
/*     To find the eigenvalues and eigenvectors (if desired) */
/*     of a DOUBLE PRECISION GENERAL matrix. */

/*     On Input */

/*        NM  must be set to the row dimension of the two-dimensional */
/*        array parameters as declared in the calling program */
/*        dimension statement. */

/*        N  is the order of the matrix  A. */

/*        A  contains the DOUBLE PRECISION general matrix. */

/*        MATZ  is an integer variable set equal to zero if */
/*        only eigenvalues are desired.  Otherwise it is set to */
/*        any non-zero integer for both eigenvalues and eigenvectors. */

/*     On Output */

/*        WR  and  WI  contain the DOUBLE PRECISION and imaginary parts, */
/*        respectively, of the eigenvalues.  Complex conjugate */
/*        pairs of eigenvalues appear consecutively with the */
/*        eigenvalue having the positive imaginary part first. */

/*        Z  contains the DOUBLE PRECISION and imaginary parts of the eigenvectors */
/*        if MATZ is not zero.  If the J-th eigenvalue is DOUBLE PRECISION, the */
/*        J-th column of  Z  contains its eigenvector.  If the J-TH */
/*        eigenvalue is complex with positive imaginary part, the */
/*        J-th and (J+1)-th columns of  Z  contain the DOUBLE PRECISION and */
/*        imaginary parts of its eigenvector.  The conjugate of this */
/*        vector is the eigenvector for the conjugate eigenvalue. */

/*        IERR  is an integer output variable set equal to an */
/*        error completion code described in section 2B of the */
/*        documentation.  The normal completion code is zero. */

/*        IV1  and  FV1  are temporary storage arrays. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  BALANC,BALBAK,ELMHES,ELTRAN,HQR,HQR2 */
/* ***END PROLOGUE  RG */

/* ***FIRST EXECUTABLE STATEMENT  RG */
   /* Parameter adjustments */
   --fv1;
   --iv1;
   z_dim1 = *nm;
   z_offset = z_dim1 + 1;
   z__ -= z_offset;
   --wi;
   --wr;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   if (*n <= *nm)
   {
      goto L10;
   }
   *ierr = *n * 10;
   goto L50;

 L10:
   balanc_ (nm, n, &a[a_offset], &is1, &is2, &fv1[1]);
   elmhes_ (nm, n, &is1, &is2, &a[a_offset], &iv1[1]);
   if (*matz != 0)
   {
      goto L20;
   }
/*     .......... FIND EIGENVALUES ONLY .......... */
   hqr_ (nm, n, &is1, &is2, &a[a_offset], &wr[1], &wi[1], ierr);
   goto L50;
/*     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS .......... */
 L20:
   eltran_ (nm, n, &is1, &is2, &a[a_offset], &iv1[1], &z__[z_offset]);
   hqr2_ (nm, n, &is1, &is2, &a[a_offset], &wr[1], &wi[1], &z__[z_offset],
          ierr);
   if (*ierr != 0)
   {
      goto L50;
   }
   balbak_ (nm, n, &is1, &is2, &fv1[1], n, &z__[z_offset]);
 L50:
   return 0;
}                                       /* rg_ */
