/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#ifndef GFMCMC_SHORTCUTS_H
#define GFMCMC_SHORTCUTS_H
/*  these are to be used internally in later #defines */
#define _gsIF                   if (gInitWinSettings[gNumWinDefs]==NULL) { gInitWinSettings[gNumWinDefs] = gfmAllocWindowSettings();  }
#define _gsIWS                  gInitWinSettings[gNumWinDefs]

/*  axis customization */

#define gsY_AXIS_LO(X)          _gsIF    _gsIWS->Yaxis->ImposeLowerLimit = 1;  _gsIWS->Yaxis->LowerLimit = (GLfloat)(X);
#define gsX_AXIS_LO(X)          _gsIF    _gsIWS->Xaxis->ImposeLowerLimit = 1;  _gsIWS->Xaxis->LowerLimit = (GLfloat)(X);

#define gsY_AXIS_HI(X)          _gsIF    _gsIWS->Yaxis->ImposeUpperLimit = 1;  _gsIWS->Yaxis->UpperLimit = (GLfloat)(X);
#define gsX_AXIS_HI(X)          _gsIF    _gsIWS->Xaxis->ImposeUpperLimit = 1;  _gsIWS->Xaxis->UpperLimit = (GLfloat)(X);

#define gsXTICKS_BELOW          _gsIF    _gsIWS->Xaxis->TickPos = AXIS_TICKS_LEFT_BELOW;
#define gsXTICKS_ABOVE          _gsIF    _gsIWS->Xaxis->TickPos = AXIS_TICKS_RIGHT_ABOVE;

#define gsYTICKS_LEFT           _gsIF    _gsIWS->Yaxis->TickPos = AXIS_TICKS_LEFT_BELOW;
#define gsYTICKS_RIGHT          _gsIF    _gsIWS->Yaxis->TickPos = AXIS_TICKS_RIGHT_ABOVE;

#define gsXTICKS_MAJOR_SIZE(X)          _gsIF    _gsIWS->Xaxis->MajorProp = (GLfloat)X;
#define gsYTICKS_MAJOR_SIZE(X)          _gsIF    _gsIWS->Yaxis->MajorProp = (GLfloat)X;

#define gsX_MAJOR_NUM(X)                _gsIF    _gsIWS->Xaxis->OptimalNumMajor = X;
#define gsY_MAJOR_NUM(X)                _gsIF    _gsIWS->Yaxis->OptimalNumMajor = X;

#define gsNO_XAXIS_NUMS                 _gsIF   _gsIWS->Xaxis->DrawNumLabels = 0;
#define gsNO_YAXIS_NUMS                 _gsIF   _gsIWS->Yaxis->DrawNumLabels = 0;

#define gsNO_Y_AXIS                             _gsIF   _gsIWS->Yaxis->DrawIt = 0;
#define gsNO_X_AXIS                             _gsIF   _gsIWS->Xaxis->DrawIt = 0;

#define gsAXES_POS_QUADRANT             gsY_AXIS_CROSSES(0.0f)  gsX_AXIS_CROSSES(0.0f) \
gsY_AXIS_LO(0.0f) gsX_AXIS_LO(0.0f) gsXTICKS_BELOW gsYTICKS_LEFT
#define gsAXES_POS_UNIT_X               gsAXES_POS_QUADRANT  gsX_AXIS_HI(1.0f);


/*  for legend customization */
#define gsNUM_COLOR_KEYS(X)     gWinDefs[gNumWinDefs]->NumColorKeys = X
#define gsCOLOR_KEYS(X)         gWinDefs[gNumWinDefs]->ColorKey = X

/*  menu attachment, etc */
#define gsMIDDLE_CLICK_MENU(X)  gWinDefs[gNumWinDefs]->MiddleMouseMenuIdx = X

/*  for setting the default color scheme */
#define gsCOLOR_SCHEME(X)       gWinDefs[gNumWinDefs]->DefaultColorSchemeIdx = X

/* vim: sw=3
*/
#endif /* GFMCMC_SHORTCUTS_H */
