/* Header file for ibd_haplo programs -- taking stuff out of ibd_haplo.c.     */
/* Program to do a basic analysis of IBD inference with no LD.                */

#include <math.h>

struct ss_size_pointers_structure
{
   int   **state_matrix;          /* The current IBD state matrix.            */
   int   num_orbits;              /* Number of nontrivial orbits.             */
   int   *orbitSizes;             /* The vector of sizes of each orbit.       */
   int   **orbits;                /* The matrix of the orbit members.         */
   double *marg_probs;            /* The marginal ibd probabilities vector.   */
   double *tmat_rate;             /* Negative-diagonal terms of base tmat.    */
   double **tmat;                 /* The base state transition matrix.        */
   double **transmat;             /* The locus-to-locus transition matrix.    */
};
typedef struct ss_size_pointers_structure SS_SIZE_STRUCTURE;

#define IS_SET(x,n) ((x) & (1 << (n)))

#define CONCORDANT   1            /* Concordant phasing at current marker.    */
#define DISCORDANT  -1            /* Discordant phasing at current marker.    */

/* Vector of score_set_size_pointers structures.                              */
SS_SIZE_STRUCTURE *score_set_size_pointers;

int   num_states;                 /* Number of possible IBD states.           */

double **pprob, *penmat;          /* nph pheno, num_states states.            */
double **transmat;              /* num_states x num_states transition matrix. */
                                  /* penmat and transmat now reset each locus */
                                  /*  and penmat only for given data.         */

double *marg_probs;               /* Marginal ibd probabilities.              */
double *tmat_rate;                /* Negative-diagonal terms of base tmat.    */
double **tmat;                    /* The base transition matrix; used to      */
                                  /*  then determine locus-to-locus transmat. */

int   *duplicated_rows;           /* A vector of 0's and 1's reflecting where */
                                  /* there are duplicate rows.                */
int   **state_matrix;             /* The IBD state matrix with all duplicated */
                                  /* rows removed.                            */

                                  /* Stuff for computing genotypic orbits.    */
int   num_orbits;                 /* Number of nontrivial orbits.             */
int   *orbitSizes;                /* The vector of sizes of each orbit.       */
int   **orbits;                   /* The matrix of the orbit members.         */

