void swap (int *x, int *y)
{
   (*x) += (*y);
   (*y) = (*x) - (*y);
   (*x) -= (*y);
}

int power (int base, int exponent)
{
   if (exponent == 0)
      return 1;
   if (exponent < 0)
      return 0;
   int   result = 1;
   int   i;
   for (i = 0; i < exponent; i++)
   {
      result *= base;
   }
   return result;
}

int stateEncode (int num_haps, int *state)
{
   int   i;
   int   encoding = 0;
   for (i = 0; i < num_haps; i++)
   {
      encoding += state[i] * power (num_haps + 1, i);
   }
   return encoding;
}

void makeOrbits (int num_haps, int ms, int **statemat)
{
   int  *encodedStates, *visited;
   int   i, k, norb, nindivs;
   unsigned j;
   int   nonSingletonOrbit;
   int  *tmpState, *tmpState2;
   int   tmp;

   tmpState = alloc_int1d (num_haps);
   tmpState2 = alloc_int1d (num_haps);

   nindivs = num_haps / 2;
   norb = 0;

   encodedStates = malloc (ms * sizeof (int));
   visited = malloc (ms * sizeof (int));

   for (i = 0; i < ms; i++)
   {
      orbitSizes[i] = 0;
   }
   for (i = 0; i < ms; i++)
   {
      encodedStates[i] = stateEncode (num_haps, statemat[i]);
      visited[i] = 0;
   }
   for (i = 0; i < ms; i++)
   {
      if (visited[i])
         continue;
      visited[i] = 1;
      nonSingletonOrbit = 0;
      for (j = 1; j < power (2, nindivs); j++)
      {
         for (k = 0; k < num_haps; k++)
         {
            tmpState[k] = statemat[i][k];
         }
         for (k = 0; k < nindivs; k++)
         {
            if (IS_SET (j, k))
               swap (tmpState + k * 2, tmpState + k * 2 + 1);
         }
         rplc (num_haps, tmpState, tmpState2);
         tmp = stateEncode (num_haps, tmpState2);
         for (k = i + 1; k < ms; k++)
         {
            if (visited[k])
               continue;
            if (tmp == encodedStates[k])
            {
               visited[k] = 1;
               if (nonSingletonOrbit)
               {
                  orbits[norb - 1][orbitSizes[norb - 1]] = k;
                  orbitSizes[norb - 1]++;
               }
               else
               {
                  norb++;
                  orbits[norb - 1][0] = i;
                  orbits[norb - 1][1] = k;
                  orbitSizes[norb - 1] = 2;
                  nonSingletonOrbit = 1;
               }
            }
         }
      }
   }

   free_1d ((void *) &tmpState);
   free_1d ((void *) &tmpState2);

   free (encodedStates);
   free (visited);

   num_orbits = norb;
   return;
}
