/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#define PNAM "pedcheck"
#include "pedcomp.h"

/**
 * @defgroup pedcheck pedcheck
 * @ingroup PedComp
 * @{
 */

int main (int argc, char *argv[])
{
   atexit (print_tail);

#if 0
   PCleanUp = clean_check;              /* NOTE:  code to free memory  */
   atexit (clean_morg);                 /* at exit is not current      */
#endif

   print_head (*argv);

   if (!proc_pars (argc, argv, PNAM))   /* process input parameter      */
      exit (EXIT_FAILURE);              /* statements                   */

   if (!proc_fils ())                   /* set up pedigree file         */
      exit (EXIT_FAILURE);              /* parameters                   */

   if (!chk_pedfil ())                  /* reads pedigree file          */
      give_up (ERR_qit);                /* checks pedigree for errors   */

   if (!ChronOut)                       /* if output file is to be      */
      sortIx ();                        /* in input order, resorts      */

   if (!mak_opedfil ())                 /* writes pedigree file         */
      give_up (ERR_qit);

   freeKey ();

   exit (EXIT_SUCCESS);
}

/** @} */
