/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "stuff.h"
#include "progSimSel.h"

/* If a morgan program starts with "atexit (clean_morg);", this function will */
/* be called when the program quits.                                          */

/* This function uses a table of main programs vs. freeing functions to call. */
/* The table structure is defined in stuff.h, but the contents must be        */
/* defined in the main program's header.  If they are defined in stuff.h,     */
/* linking complications arise.                                               */

extern struct _progSimSel ProgSimSel[];

void clean_morg (void)
{
   static int entered = FALSE;

   struct _progSimSel *pm;
   struct _cleanup *pc;

   if (entered)                         /* Cleanup (ie, free memory) if it    */
      return;                           /* has not already been done.         */
   entered = TRUE;

   for (pm = ProgSimSel; pm->pnam[0] != NUL /* Get program code.              */
        && strcmp (ProgNam, pm->pnam); ++pm)
      ;

   for (pc = PCleanUp; pc->pcods[0] != NUL; ++pc)
      if (strchr (pc->pcods, pm->pcod)) /* Get cleanup functions.             */
         (pc->func) ();

   return;
}
